using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using ZedGraph;
using System.IO;


namespace Clustering
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		private ZedGraph.ZedGraphControl zdGraph;
		private System.Windows.Forms.SaveFileDialog dlgSave;
		private System.Windows.Forms.TextBox txtX;
		private System.Windows.Forms.TextBox txtY;
		private System.Windows.Forms.Button btnAddRem;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.RadioButton rbSingle;
		private System.Windows.Forms.RadioButton rbAverage;
		private System.Windows.Forms.RadioButton rbComplete;
		private System.Windows.Forms.RadioButton rbWard;
		private System.Windows.Forms.RadioButton rbForgy;
		private System.Windows.Forms.Button btnLoad;
		private System.Windows.Forms.Button btnSave;
		private System.Windows.Forms.TrackBar trkSpeed;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button btnCluster;

		private ArrayList clusterList;
		
		
		private Random random;
		private System.Windows.Forms.OpenFileDialog dlgLoad;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			clusterList=new ArrayList();
			random=new Random();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.zdGraph = new ZedGraph.ZedGraphControl();
			this.dlgLoad = new System.Windows.Forms.OpenFileDialog();
			this.dlgSave = new System.Windows.Forms.SaveFileDialog();
			this.txtX = new System.Windows.Forms.TextBox();
			this.txtY = new System.Windows.Forms.TextBox();
			this.btnAddRem = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.rbSingle = new System.Windows.Forms.RadioButton();
			this.rbAverage = new System.Windows.Forms.RadioButton();
			this.rbComplete = new System.Windows.Forms.RadioButton();
			this.rbWard = new System.Windows.Forms.RadioButton();
			this.rbForgy = new System.Windows.Forms.RadioButton();
			this.btnLoad = new System.Windows.Forms.Button();
			this.btnSave = new System.Windows.Forms.Button();
			this.trkSpeed = new System.Windows.Forms.TrackBar();
			this.label3 = new System.Windows.Forms.Label();
			this.btnCluster = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.trkSpeed)).BeginInit();
			this.SuspendLayout();
			// 
			// zdGraph
			// 
			this.zdGraph.IsShowPointValues = false;
			this.zdGraph.Location = new System.Drawing.Point(208, 0);
			this.zdGraph.Name = "zdGraph";
			this.zdGraph.PointValueFormat = "G";
			this.zdGraph.Size = new System.Drawing.Size(480, 448);
			this.zdGraph.TabIndex = 0;
			// 
			// dlgLoad
			// 
			this.dlgLoad.DefaultExt = "dat";
			this.dlgLoad.Filter = "Data sets|*.dat";
			this.dlgLoad.Title = "Open Data Set";
			// 
			// dlgSave
			// 
			this.dlgSave.DefaultExt = "dat";
			this.dlgSave.Filter = "Data set|*.dat";
			this.dlgSave.Title = "Save Data Set";
			// 
			// txtX
			// 
			this.txtX.Location = new System.Drawing.Point(40, 56);
			this.txtX.Name = "txtX";
			this.txtX.Size = new System.Drawing.Size(56, 20);
			this.txtX.TabIndex = 1;
			this.txtX.Text = "";
			// 
			// txtY
			// 
			this.txtY.Location = new System.Drawing.Point(40, 96);
			this.txtY.Name = "txtY";
			this.txtY.Size = new System.Drawing.Size(56, 20);
			this.txtY.TabIndex = 2;
			this.txtY.Text = "";
			// 
			// btnAddRem
			// 
			this.btnAddRem.Location = new System.Drawing.Point(104, 64);
			this.btnAddRem.Name = "btnAddRem";
			this.btnAddRem.Size = new System.Drawing.Size(80, 40);
			this.btnAddRem.TabIndex = 3;
			this.btnAddRem.Text = "Add/Remove Point";
			this.btnAddRem.Click += new System.EventHandler(this.btnAddRem_Click);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(8, 56);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(32, 23);
			this.label1.TabIndex = 4;
			this.label1.Text = "X:";
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(8, 96);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(32, 23);
			this.label2.TabIndex = 5;
			this.label2.Text = "Y:";
			// 
			// rbSingle
			// 
			this.rbSingle.Checked = true;
			this.rbSingle.Location = new System.Drawing.Point(40, 136);
			this.rbSingle.Name = "rbSingle";
			this.rbSingle.Size = new System.Drawing.Size(120, 24);
			this.rbSingle.TabIndex = 6;
			this.rbSingle.TabStop = true;
			this.rbSingle.Text = "Single Linkage";
			// 
			// rbAverage
			// 
			this.rbAverage.Location = new System.Drawing.Point(40, 200);
			this.rbAverage.Name = "rbAverage";
			this.rbAverage.Size = new System.Drawing.Size(120, 24);
			this.rbAverage.TabIndex = 8;
			this.rbAverage.Text = "Average Linkage";
			// 
			// rbComplete
			// 
			this.rbComplete.Location = new System.Drawing.Point(40, 168);
			this.rbComplete.Name = "rbComplete";
			this.rbComplete.Size = new System.Drawing.Size(120, 24);
			this.rbComplete.TabIndex = 9;
			this.rbComplete.Text = "Complete Linkage";
			// 
			// rbWard
			// 
			this.rbWard.Location = new System.Drawing.Point(40, 232);
			this.rbWard.Name = "rbWard";
			this.rbWard.Size = new System.Drawing.Size(120, 24);
			this.rbWard.TabIndex = 10;
			this.rbWard.Text = "Ward\'s Algorithm";
			// 
			// rbForgy
			// 
			this.rbForgy.Location = new System.Drawing.Point(40, 264);
			this.rbForgy.Name = "rbForgy";
			this.rbForgy.Size = new System.Drawing.Size(120, 24);
			this.rbForgy.TabIndex = 11;
			this.rbForgy.Text = "Forgy\'s Algorithm";
			// 
			// btnLoad
			// 
			this.btnLoad.Location = new System.Drawing.Point(8, 8);
			this.btnLoad.Name = "btnLoad";
			this.btnLoad.Size = new System.Drawing.Size(75, 32);
			this.btnLoad.TabIndex = 12;
			this.btnLoad.Text = "Load Data Set";
			this.btnLoad.Click += new System.EventHandler(this.btnLoad_Click);
			// 
			// btnSave
			// 
			this.btnSave.Location = new System.Drawing.Point(104, 8);
			this.btnSave.Name = "btnSave";
			this.btnSave.Size = new System.Drawing.Size(75, 32);
			this.btnSave.TabIndex = 13;
			this.btnSave.Text = "Save Data Set";
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// trkSpeed
			// 
			this.trkSpeed.Location = new System.Drawing.Point(64, 368);
			this.trkSpeed.Name = "trkSpeed";
			this.trkSpeed.Size = new System.Drawing.Size(128, 45);
			this.trkSpeed.TabIndex = 14;
			this.trkSpeed.Value = 10;
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(8, 376);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(48, 23);
			this.label3.TabIndex = 15;
			this.label3.Text = "Speed:";
			// 
			// btnCluster
			// 
			this.btnCluster.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnCluster.Location = new System.Drawing.Point(56, 304);
			this.btnCluster.Name = "btnCluster";
			this.btnCluster.TabIndex = 16;
			this.btnCluster.Text = "Cluster!";
			this.btnCluster.Click += new System.EventHandler(this.btnCluster_Click);
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(688, 446);
			this.Controls.Add(this.btnCluster);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.trkSpeed);
			this.Controls.Add(this.btnSave);
			this.Controls.Add(this.btnLoad);
			this.Controls.Add(this.rbForgy);
			this.Controls.Add(this.rbWard);
			this.Controls.Add(this.rbComplete);
			this.Controls.Add(this.rbAverage);
			this.Controls.Add(this.rbSingle);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.btnAddRem);
			this.Controls.Add(this.txtY);
			this.Controls.Add(this.txtX);
			this.Controls.Add(this.zdGraph);
			this.Name = "frmMain";
			this.Text = "Clustering Algorithm Teaching Tool";
			((System.ComponentModel.ISupportInitialize)(this.trkSpeed)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private void updateGraph()
		{
			zdGraph.GraphPane.CurveList.Clear();
			int i=0;
			foreach (object o in clusterList)
			{
				i++;
				PointPairList lst=new PointPairList();
				foreach (object p in (ArrayList)o)
				{
					Point pt=(Point)p;
					lst.Add(pt.x,pt.y);
				}
				LineItem myCurve = zdGraph.GraphPane.AddCurve("Cluster "+i,lst,Color.FromArgb(random.Next(256),random.Next(256),random.Next(256)),SymbolType.Square);
				//myCurve.Line.IsVisible = true;
				myCurve.Symbol.Fill=new Fill(Color.FromArgb(random.Next(256),random.Next(256),random.Next(256)));
			}
			zdGraph.GraphPane.AxisChange(this.CreateGraphics());
			zdGraph.Refresh();
		}

		private void btnAddRem_Click(object sender, System.EventArgs e)
		{
			try
			{
				Point pt=new Point(Convert.ToDouble(txtX.Text),Convert.ToDouble(txtY.Text));
				Point erasePoint=null;
				ArrayList eraseCluster=null;
				foreach (object clust in clusterList)
					foreach (object point in (ArrayList)clust)
					{
						if (pt.Equals(point))
						{
							erasePoint=(Point)point;
							eraseCluster=(ArrayList)clust;
						}
					}
				if (erasePoint!=null)
				{
					if (eraseCluster.Count>1)
						eraseCluster.Remove(erasePoint);
					if (eraseCluster.Count==1)
						clusterList.Remove(eraseCluster);
				}
				else
				{
					ArrayList cluster = new ArrayList();
					cluster.Add(pt);
					clusterList.Add(cluster);
				}
				updateGraph();
			} 
			catch (Exception ex){}

		}

		private void singleLinkage ()
		{
			double minDistance=double.MaxValue;
			ArrayList cluster1=null;
			ArrayList cluster2=null;
			foreach (object clusterI in clusterList)
			{
				//finding the min distance between 2 clusters
				foreach (object clusterJ in clusterList)
					if (clusterI!=clusterJ)
					{
						//find the min distance between a pt in 1 cluster and a pt in another
						foreach (object pt1 in (ArrayList)clusterI)
							foreach (object pt2 in (ArrayList)clusterJ)
							{
								double distance=((Point)pt1).eDistance((Point)pt2);
								if (distance<minDistance)
								{
									minDistance=distance;
									cluster1=((ArrayList)clusterI);
									cluster2=((ArrayList)clusterJ);
								}
							}
					}

			}
			//merge clusters
			((ArrayList)cluster1).InsertRange(((ArrayList)cluster1).Count,(ArrayList)cluster2);
			clusterList.Remove(cluster2);
		}

		private void completeLinkage ()
		{
			double minDistance=double.MaxValue;
			ArrayList cluster1=null;
			ArrayList cluster2=null;
			foreach (object clusterI in clusterList)
			{
				//finding the min distance between 2 clusters
				foreach (object clusterJ in clusterList)
					if (clusterI!=clusterJ)
					{
						//find the max distance between a pt in 1 cluster and a pt in another
						double maxDistance=0;
						foreach (object pt1 in (ArrayList)clusterI)
							foreach (object pt2 in (ArrayList)clusterJ)
							{
								double distance=((Point)pt1).eDistance((Point)pt2);
								if (distance>maxDistance)
									maxDistance=distance;
									
							}
						if (maxDistance<minDistance)
						{
							minDistance=maxDistance;
							cluster1=(ArrayList)clusterI;
							cluster2=(ArrayList)clusterJ;
						}
					}

			}
			//merge clusters
			((ArrayList)cluster1).InsertRange(((ArrayList)cluster1).Count,(ArrayList)cluster2);
			clusterList.Remove(cluster2);
		}

		private void averageLinkage ()
		{
			double minDistance=double.MaxValue;
			ArrayList cluster1=null;
			ArrayList cluster2=null;
			foreach (object clusterI in clusterList)
			{
				//finding the min distance between 2 clusters
				foreach (object clusterJ in clusterList)
					if (clusterI!=clusterJ)
					{
						//find the average distance between a pt in 1 cluster and a pt in another
						double x1=0;
						double y1=0;
						foreach (object pt in (ArrayList)clusterI)
						{
							x1+=((Point)pt).x;
							y1+=((Point)pt).y;
						}
						x1/=((ArrayList)clusterI).Count;
						y1/=((ArrayList)clusterI).Count;
						double x2=0;
						double y2=0;
						foreach (object pt in (ArrayList)clusterJ)
						{
							x2+=((Point)pt).x;
							y2+=((Point)pt).y;
						}
						x2/=((ArrayList)clusterJ).Count;
						y2/=((ArrayList)clusterJ).Count;
						double distance=new Point(x1,y1).eDistance(new Point(x2,y2));
						if (distance<minDistance)
						{
							minDistance=distance;
							cluster1=((ArrayList)clusterI);
							cluster2=((ArrayList)clusterJ);
						}
					}

			}
			//merge clusters
			((ArrayList)cluster1).InsertRange(((ArrayList)cluster1).Count,(ArrayList)cluster2);
			clusterList.Remove(cluster2);
		}

		private void wards()
		{
			ArrayList cluster1=null;
			ArrayList cluster2=null;
			double minError=double.MaxValue;
			foreach (object clusterI in clusterList)
			{
				//finding the square error of the 2 clusters merged
				foreach (object clusterJ in clusterList)
					if (clusterI!=clusterJ)
					{
						double distance=squareError((ArrayList)clusterI,(ArrayList)clusterJ);
						if (distance<minError)
						{
							minError=distance;
							cluster1=((ArrayList)clusterI);
							cluster2=((ArrayList)clusterJ);
						}
					}
			}
			//merge clusters
			cluster1.InsertRange(cluster1.Count,cluster2);
			clusterList.Remove(cluster2);
		}

		public double squareError(ArrayList cluster1, ArrayList cluster2)
		{
			double xm=0;
			double ym=0;
			foreach (object pt in cluster1)
			{
				xm+=((Point)pt).x;
				ym+=((Point)pt).y;
			}
			foreach (object pt in cluster2)
			{
				xm+=((Point)pt).x;
				ym+=((Point)pt).y;
			}
			xm/=(cluster1.Count+cluster2.Count);
			ym/=(cluster1.Count+cluster2.Count);
			double squareErr=0;
			foreach (object pt in cluster1)
			{
				squareErr+=Math.Pow((((Point)pt).x-xm),2);
				squareErr+=Math.Pow((((Point)pt).y-ym),2);
			}
			foreach (object pt in cluster2)
			{
				squareErr+=Math.Pow((((Point)pt).x-xm),2);
				squareErr+=Math.Pow((((Point)pt).y-ym),2);
			}
			return squareErr;
		}
		
		public void forgy()
		{
			//first turn all clusters into 1
			ArrayList ptList=new ArrayList(clusterList.Count);
			foreach (object o in clusterList)
				ptList.InsertRange(ptList.Count,(ArrayList)o);
			clusterList=new ArrayList(2);
			clusterList.Add(ptList);
			ptList=new ArrayList(ptList); //fresh copy of the same arraylist (the other is modified)
			//delay here & updateGraph
			updateGraph();
			System.Threading.Thread.Sleep((10-trkSpeed.Value)*100);
			bool f=true;
			Point centroid1=(Point)ptList[0];
			Point centroid2=(Point)ptList[1];
			clusterList.Add(new ArrayList());
			while (f)
			{
				//clear clusterList
				((ArrayList)clusterList[0]).Clear();
				((ArrayList)clusterList[1]).Clear();
				foreach (object o in ptList)
				{
					if (centroid1.eDistance((Point)o)<centroid2.eDistance((Point)o))
						((ArrayList)clusterList[0]).Add(new Point(((Point)o).x,((Point)o).y));
					else ((ArrayList)clusterList[1]).Add(new Point(((Point)o).x,((Point)o).y));
					
                }
				//recompute centroids
				Point newCentroid1=new Point(0,0);
				Point newCentroid2=new Point(0,0);
				foreach (object o in (ArrayList)clusterList[0])
				{
					newCentroid1.x+=((Point)o).x;
					newCentroid1.y+=((Point)o).y;
				}
				foreach (object o in (ArrayList)clusterList[1])
				{
					newCentroid2.x+=((Point)o).x;
					newCentroid2.y+=((Point)o).y;
				}
				newCentroid1.x/=((ArrayList)clusterList[0]).Count;
				newCentroid1.y/=((ArrayList)clusterList[0]).Count;
				newCentroid2.x/=((ArrayList)clusterList[1]).Count;
				newCentroid2.y/=((ArrayList)clusterList[1]).Count;
				//check if changed
				if (f=!newCentroid1.Equals(centroid1)&&!newCentroid2.Equals(centroid2))
				{
					centroid1=newCentroid1;
					centroid2=newCentroid2;
				}
				System.Threading.Thread.Sleep((10-trkSpeed.Value)*50);
				updateGraph();
			}
			
		}

		private void btnCluster_Click(object sender, System.EventArgs e)
		{
			if ((clusterList.Count)>1)
			{
				if (rbSingle.Checked) singleLinkage();
				if (rbComplete.Checked) completeLinkage();
				if (rbAverage.Checked) averageLinkage();
				if (rbWard.Checked) wards();
				updateGraph();
			}
			if (rbForgy.Checked) forgy();
			updateGraph();
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			dlgSave.ShowDialog();
			String filename=dlgSave.FileName;
			if (filename!="")
			{
				TextWriter tr = new StreamWriter(filename);
				foreach (object cluster in clusterList)
				{
					tr.WriteLine("/");
					foreach (object pt in (ArrayList)cluster)
					{
						tr.WriteLine(Convert.ToString(((Point)pt).x));
						tr.WriteLine(Convert.ToString(((Point)pt).y));
					}
									
				}
				tr.WriteLine("/");
				tr.Close();
			}
		}

		private void btnLoad_Click(object sender, System.EventArgs e)
		{
			dlgLoad.ShowDialog();
			String filename=dlgLoad.FileName;
			if (filename!="")
			{
				//clear previous clusters
				clusterList.Clear();
				TextReader tr = new StreamReader(filename);
				String s;
				ArrayList list=null;
				while ((s=tr.ReadLine())!=null && s!="")
				{
					if (s=="/")
					{
						//insert previous list
						if (list!=null)
							clusterList.Add(list);
						list=new ArrayList();

					} 
					else
					{
						double x=Convert.ToDouble(s);
						s=tr.ReadLine();
						list.Add(new Point(x,Convert.ToDouble(s)));
					}
				}
				tr.Close();


			}
			updateGraph();
		}
		
	}
}
